<?php
set_time_limit(60*10);

$wire_x = array();
$wire_y = array();
$central_x = 0;
$central_y = 0;

// $wires = ["R8,U5,L5,D3", "U7,R6,D4,L4"]; // FIRST EXAMPLE
// $wires = ["R75,D30,R83,U83,L12,D49,R71,U7,L72", "U62,R66,U55,R34,D71,R55,D58,R83"];
// $wires = ["R98,U47,R26,D63,R33,U87,L62,D20,R33,U53,R51", "U98,R91,D20,R16,D67,R40,U7,R15,U6,R7"];

$input = file_get_contents("day3.txt");
$wires = explode("\n",$input, 2);

// var_dump($wires);
// die();
foreach($wires as $key => $wire){
  $wire_x[$key][0] = 0;
  $wire_y[$key][0] = 0;
  $wire_steps[$key] = []; //PART 2
  
  foreach(explode(",",$wire) as $inst){
    $dir = substr($inst, 0, 1);
    $num = substr($inst, 1);
    
    $wire_steps[$key][] = $num; //PART 2

    if(is_numeric($num)){

      // echo $dir."-".$num."<br>\n";
      
      for($i = 0; $i < $num; $i++){
        if($dir == "L"){ 
          $wire_x[$key][] = $wire_x[$key][array_key_last($wire_x[$key])]-1;
          $wire_y[$key][] = $wire_y[$key][array_key_last($wire_y[$key])];
        }
        elseif($dir == "D"){ 
          $wire_x[$key][] = $wire_x[$key][array_key_last($wire_x[$key])];
          $wire_y[$key][] = $wire_y[$key][array_key_last($wire_y[$key])]-1;
        }
        elseif($dir == "R"){ 
          $wire_x[$key][] = $wire_x[$key][array_key_last($wire_x[$key])]+1;
          $wire_y[$key][] = $wire_y[$key][array_key_last($wire_y[$key])];
        }
        elseif($dir == "U"){ 
          $wire_x[$key][] = $wire_x[$key][array_key_last($wire_x[$key])];
          $wire_y[$key][] = $wire_y[$key][array_key_last($wire_y[$key])]+1;
        }
      }
    }
  }

  foreach($wire_x[$key] as $pos => $dummy){
    $wireStrArr[$key][$pos] = $wire_x[$key][$pos].",".$wire_y[$key][$pos];
  }
}

// print_r($wire_steps);
// die();

$newArr = array_flip($wireStrArr[1]);
$smallestDistance = 999999999;
$bestSteps = 999999999;
foreach($wireStrArr[0] as $pos => $value){

  if(isset($newArr[$value]) && $pos > 0){
    echo "Meetings at: x$pos (".$wire_x[0][$pos].",".$wire_y[0][$pos].") - ";
    $distance = ((sqrt( pow($wire_x[0][$pos],2) ))+(sqrt( pow($wire_y[0][$pos],2) )));
    //PART 1
    echo "Distance: ".$distance." - ";
    if($distance < $smallestDistance){ $smallestDistance = $distance; }

    //PART 2
    // wire1's position: $pos
    // wire2's: $newArr[$value]
    $steps = $pos+$newArr[$value];
    echo "Steps: ".$steps."<br>\n";
    if($steps < $bestSteps){ $bestSteps = $steps; }
  }
}

echo "<h3>Smallest distance: $smallestDistance</h3>";
echo "<h3>Best steps: $bestSteps</h3>"; // PART 2

die();
echo "<br/><pre style='float:left;'>";
print_r($wire_x);
echo "</pre>";
echo "<pre style='float:left;'>";
print_r($wire_y);
echo "</pre>";


?>