<?php
/*
- 6 digit number
- Within puzzle input range
- Two adjacent numbers are equal
- Number has increasing digits
*/

// Puzzle Input:
$input = "153517-630395";
// $input = "111111-630395";
$totalPossible = 0;
$totalPossiblePart2 = 0;

list($pwdStart, $pwdEnd) = explode("-",$input);

for ($i=$pwdStart; $i < $pwdEnd; $i++) {
// for ($i=$pwdStart; $i < $pwdStart+10000; $i++) {
  $lastVal = 0;
  $valid = false;
  $validP2 = false;
  
  //HAS SAME VALUE
  if(strstr($i, "00") || strstr($i, "11") || strstr($i, "22") || strstr($i, "33") || strstr($i, "44") || 
     strstr($i, "55") || strstr($i, "66") || strstr($i, "77") || strstr($i, "88") || strstr($i, "99")){
    $valid = true;
  }

  if($valid){
    //Increasing
    foreach(str_split($i) as $key => $val){
      // echo $key.": ".$val."<br>";
      if($val < $lastVal){ $valid = false; }
      $lastVal = $val;
    }
  }

  if($valid){ 
    // echo "P1-valid: ".$i."<br>\n";
    $totalPossible++;

    // PART 2
    $validP2 = false;
    for($j = 9; $j >= 0; $j--){
      if(substr_count($i,$j) == 2){
        $validP2 = true;
        break;
      }
    }
    if($validP2){ 
      // echo "P2-valid: ".$i."<br>\n";
      $totalPossiblePart2++;
    }
    
  }
}

echo "<h2>Part 1 - possibilities: ".$totalPossible."</h2>";
echo "<h2>Part 2 - possibilities: ".$totalPossiblePart2."</h2>";

?>
